#include <stdio.h>
#include "sem.h"


main(int argc, char *argv[])
{
  int i, mode, uid, gid;
  int semid;


  mode = 0600;
  uid  = getuid();
  gid  = getgid();
  
  for (i = 1; i < argc && argv[i][0] == '-'; i++)
    switch (argv[i][1])
    {
      case 'm':
        sscanf(argv[i]+2, "%o", &mode);
	break;

      case 'u':
	uid = atoi(argv[i]+2);
	break;

      case 'g':
	gid = atoi(argv[i]+2);
	break;

      default:
	printf("semcreat: illegal option: '%s'.\n", argv[i]);
	exit(1);
    }

  if (i + 1 >= argc)
  {
    puts("syntax: semcreat [<options>] <key> <sems>");
    exit(1);
  }

  semid = sem_create(atoi(argv[i]), atoi(argv[i+1]));
  if (semid == -1)
  {
    perror("semcreat: creating semaphore group");
    exit(1);
  }

  if (sem_access(semid, uid, gid, mode) == -1)
  {
    perror("semcreat: updating access");
    exit(1);
  }
  
  printf("Semaphore group #%d created.\n", semid);
}
